#include "TMDlib.h"
//using namespace TMDlib; 
using namespace std;

     extern int iset ;

/*!
 * TMDalphas 1st part 
 */
     double TMDlib::TMDalphas(double mu) {
     double alphas ;
     static double mass[6] = { 0.,0.,0.,1.35,4.8,175. };
     double const c3=2./27.,c23=107./2025., c5=2./23.;   
     double const c25=-2.*963./13225.,c6=2./21,c26=-2.*321./3381.;
     static double pi = atan(1.) * 4.;
     double q2eff, alam2, q2thr;
     double b0, b1;
     double d1,d2,d3;
     
     double qcdlam, ret_val ;

     static 	int nf =4 ;
     static int nfmin = 3;
     static int nfmax = 5;
     
     int ialps;

     if(iset < 0 ) { 
        cout << " TMDalphas: iset is not defined " << endl; 
        return -9999 ;}
     else if ( iset >=101200 && iset <= 101320) {
           qcdlam = 0.2 ;
           ialps = 2;
           }
     else { 
         cout << " TMDalphas: iset is not defined " << endl; 
         return -9999 ;
     }

     if (ialps==0) {
         cout << " TMDalphas: ialps not set " << endl;
         return -9999 ; 
     }
     // effective q2
     q2eff = mu*mu;

     // Lambda_qcd wrt to nf flavors
     alam2 = qcdlam*qcdlam;
L100:
     if ( nf > max(2,nfmin)) {
        q2thr = mass[nf - 1] * mass[nf - 1] ;
        if ( q2eff < q2thr ) { 
           --nf ;
           cout << " test nf-- = "<<nf <<endl;
           if ( nf == 3) { 
               d1 = q2thr / alam2;
               alam2 *= pow(d1,c3);
               if (ialps == 2) {
                   d1 = log(q2thr / alam2);
                   alam2 *= pow(d1,c23);
               }
           }
           goto L100;
        }
     }   
L110:
     if ( nf < min(8,nfmax)) {
         q2thr = mass[nf] * mass[nf] ;
         if ( q2eff > q2thr ) { 
            ++nf ;
            if ( nf == 5) { 
		    d1 = alam2 / q2thr;
		    alam2 *= pow(d1,c5);
		    if (ialps == 2) {
		        d1 = log(q2thr / alam2);
		        alam2 *= pow(d1,c25);
		    }
           cout << " alam2=5: " << alam2 << endl;
            }
            if (nf == 6) {
	   	    d1 = alam2 / q2thr;
		    alam2 *= pow(d1, c6);
		    if (ialps == 2) {
		        d1 = log(q2thr / alam2);
		        alam2 *= pow(d1, c26);
		    }
	      }
            goto L110;
         }
    }
    if (nf > 6 || nf <= 0) {
        cout << " TMDalphas problem at nf = " << nf << " and mu  = " << mu << endl;
    }
   
    b0 = (33. - nf * 2.) / 6.;
    d1 = 1.0001, d2 = q2eff / alam2;
    double algq = log((max(d1,d2)));
  
    if (ialps == 1) {
	d1 = 10., d2 = pi * 2. / (b0 * algq);
	ret_val = min(d1,d2);
      } else {
	b1 = (153. - nf * 19.) / 6.;
	d3 = b0;
	d1 = 10.;
      d2 = pi * 2./ (b0 * algq) * (1. - b1 * log(algq)/(d3 * d3 * algq));
	ret_val = min(d1,d2);
    }
     
    return ret_val ;  
      
}

