#include "TMDlib.h"
#include <fstream>
#include <iomanip>
using namespace std;
using namespace TMDlib;

int main() {
 
  string name ;
  //name = "GBWlight";
  name ="ccfm-JH-2013-set1";
  
  double x, xbar, kt, mu;
  double mz = 91.18;
  double uval, dval, sea, charm, bottom, gluon;
  
  x = 0.01 ;
  xbar = 0 ; 
  kt = 10. ;
  mu = 100 ;
  int irep=0, imode=0 ;
  TMDinit(name, irep, imode);
  
  cout << "alphas(mz)  = " << TMDlib::TMDalphas(mz) << endl;
  cout << "Order alfas = " << TMDlib::TMDgetOrderAlphaS() << endl;
  cout << "qcdlam4     = " << TMDlib::TMDgetLam4() << endl;
  cout << "order PDF   = " << TMDlib::TMDgetOrderPDF() << endl;
  cout << "xmin        = " << TMDlib::TMDgetXmin() << endl;
  cout << "xmax        = " << TMDlib::TMDgetXmax() << endl;
  cout << "q2min       = " << TMDlib::TMDgetQ2min() << endl;
  cout << "q2max       = " << TMDlib::TMDgetQ2max() << endl;
  cout << "num flav    = " << TMDlib::TMDgetNf() << endl;
  cout << "number      = " << TMDlib::TMDnumberPDF(name) << endl;
  cout << endl;
  
  
  TMDpdf(x,xbar,kt,mu, uval, dval, sea, charm, bottom, gluon);
  cout << " TMDlib call without kf " << uval << " " << dval << " " << gluon << endl;
  int kf = -2212;
  TMDpdf(kf, x,xbar,kt,mu, uval, dval, sea, charm, bottom, gluon);
  cout << " TMDlib call with kf    " << uval << " " << dval << " " << gluon << endl;
  
  vector<double> arr(13);
  double* xpq = &arr[6];
  
  TMDpdf(x,xbar,kt,mu, arr);
  cout << " TMDlib call without kf " << arr[8] << " " << arr[7] << " " << arr[6] << endl;
  cout << " TMDlib call without kf " << xpq[2] << " " << xpq[1] << " " << xpq[0] << endl;
  
  
  
  //        vector<double> TMDpdf;
  //        xpq = &TMDpdf[6];
  
  //        TMDpdf(kf, x,xbar,kt,mu);
  //        cout << " TMDlib call with kf " << TMDpdf[1] << " " << TMDpdf[2] << " " << TMDpdf[0] << endl;
  
  
}
