#include "TMDlib.h"
#include <iostream>
#include <sstream>
#include <string>  
using namespace std;
using namespace TMDlib;

// Root includes
#include "TH1.h"
#include "TH2.h"
#include "TFile.h" 
#include "TCanvas.h"
#include <TApplication.h>
#include <TStyle.h>
#include <TROOT.h>
#include "TLegend.h"
#include "TLatex.h"

int main(int argc,char **argv) {

TApplication* gMyRootApp = new TApplication("My ROOT Application", &argc, argv);

double kt,mu ;

int kf;
double xmin=0.06, xmax=0.41 ;
double uval, dval, sea, charm, bottom, gluon;
string name ;


// set constants 
   kt = 2. ;  /* tranverse momentum k_t */
   mu = sqrt(2.4) ;   /* evolution scale p */
      cout << " ************************************************" << endl;
      cout << " *                   TMDplotter                 *" << endl;
      cout << " ************************************************" << endl;
      cout << " at k_t = " << kt << " mu = " << mu << endl;
      cout << " for x_min = " << xmin << "  x_max = "  << xmax << endl;
      
      
      
int npoint=50 ;

double log_xmin=log10(xmin),log_xmax=log10(xmax) ;
// histogram declaration 
      TH1F *h_gluon1 = new TH1F("xgluon at kt=0.1 GeV ","xgluon1",npoint, log_xmin, log_xmax);
      TH1F *h_uval1 = new TH1F("xuval at kt=0.1 GeV ","xuval1",npoint, log_xmin, log_xmax);
      TH1F *h_dval1 = new TH1F("xdval at kt=0.1 GeV","xdval1",npoint, log_xmin, log_xmax);
      TH1F *h_sea1 = new TH1F("xsea at kt=0.1 GeV","xsea1",npoint, log_xmin, log_xmax);

      TH1F *h_gluon2 = new TH1F("xgluon at kt=1 GeV ","xgluon2",npoint, log_xmin, log_xmax);
      TH1F *h_uval2 = new TH1F("xuval at kt=1 GeV ","xuval2",npoint, log_xmin, log_xmax);
      TH1F *h_dval2 = new TH1F("xdval at kt=1 GeV","xdval2",npoint, log_xmin, log_xmax);
      TH1F *h_sea2 = new TH1F("xsea at kt=1 GeV","xsea2",npoint, log_xmin, log_xmax);

      TH1F *h_gluon3 = new TH1F("xgluon at kt=10 GeV ","xgluon3",npoint, log_xmin, log_xmax);
      TH1F *h_uval3 = new TH1F("xuval at kt=10 GeV ","xuval3",npoint, log_xmin, log_xmax);
      TH1F *h_dval3 = new TH1F("xdval at kt=10 GeV","xdval3",npoint, log_xmin, log_xmax);
      TH1F *h_sea3 = new TH1F("xsea at kt=10 GeV","xsea3",npoint, log_xmin, log_xmax);

      TH1F *h_gluon10 = new TH1F("xgluon10 at kt=0.1 GeV ","xgluon10",npoint, log_xmin, log_xmax);
      TH1F *h_uval10 = new TH1F("xuval10 at kt=0.1 GeV ","xuval10",npoint, log_xmin, log_xmax);
      TH1F *h_dval10 = new TH1F("xdval10 at kt=0.1 GeV","xdval10",npoint, log_xmin, log_xmax);
      TH1F *h_sea10 = new TH1F("xsea10 at kt=0.1 GeV","xsea10",npoint, log_xmin, log_xmax);

      TH1F *h_gluon20 = new TH1F("xgluon20 at kt=1 GeV ","xgluon20",npoint, log_xmin, log_xmax);
      TH1F *h_uval20 = new TH1F("xuval20 at kt=1 GeV ","xuval20",npoint, log_xmin, log_xmax);
      TH1F *h_dval20 = new TH1F("xdval20 at kt=1 GeV","xdval20",npoint, log_xmin, log_xmax);
      TH1F *h_sea20 = new TH1F("xsea20 at kt=1 GeV","xsea20",npoint, log_xmin, log_xmax);

      TH1F *h_gluon30 = new TH1F("xgluon30 at kt=10 GeV ","xgluon30",npoint, log_xmin, log_xmax);
      TH1F *h_uval30 = new TH1F("xuval30 at kt=10 GeV ","xuval30",npoint, log_xmin, log_xmax);
      TH1F *h_dval30 = new TH1F("xdval30 at kt=10 GeV","xdval30",npoint, log_xmin, log_xmax);
      TH1F *h_sea30 = new TH1F("xsea30 at kt=10 GeV","xsea30",npoint, log_xmin, log_xmax);
//

double deltax = (log_xmax-log_xmin)/npoint;  
double xbar = 0.; 



double kval[] ={ 1.000000e-01,   1.00000e-00 , 10.000000e+00 };

int nval = 1;

for (int j=0; j<=nval; j++){
    kt = kval[j];

    for ( int iloop=0; iloop <=npoint; iloop++) {
    double x = pow(10,(log_xmin + deltax * iloop)); 
     
       name="ccfm-JH-2013-set2";
       TMDinit(name) ;
     
       TMDpdf(x,xbar,kt,mu, uval, dval, sea, charm, bottom, gluon);

//       cout << " x " << x << " gluon = " << gluon << " " <<  uval << " " << dval << endl;
       if( j == 0 ) {
          h_gluon1 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval1  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval1  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea1   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }
      else if ( j == 1 ) {
          h_gluon2 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval2  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval2  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea2   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }
      else if ( j == 2 ) {
          h_gluon3 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval3  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval3  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea3   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }

       name="SBRS-2013-TMDPDFs";
       TMDinit(name) ;
     
       TMDpdf(x,xbar,kt,mu, uval, dval, sea, charm, bottom, gluon);

//       cout << " x " << x << " gluon = " << gluon << " " <<  uval << " " << dval << endl;
       if( j == 0 ) {
          h_gluon10 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval10  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval10  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea10   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }
      else if ( j == 1 ) {
          h_gluon20 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval20  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval20  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea20   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }
      else if ( j == 2 ) {
          h_gluon30 -> Fill(log10(x)+deltax/100/npoint,gluon) ;
          h_uval30  -> Fill(log10(x)+deltax/100/npoint,uval) ;
          h_dval30  -> Fill(log10(x)+deltax/100/npoint,dval) ;
          h_sea30   -> Fill(log10(x)+deltax/100/npoint,sea) ;
      }
      
}
} 



//    write histogramm out to file
      TFile file("output.root","RECREATE");
//general root settings 
      gROOT->Reset();
      gROOT->SetStyle("Plain");
      gStyle->SetPadTickY(1); // ticks at right side
      gStyle->SetOptStat(0); // get rid of statistics box
      TCanvas *c = new TCanvas("ctest", "" ,0, 0, 500, 500);
// divide the canvas in 1 parts in x and 1 in y

      c -> Divide(2,2);
      c -> cd(1);
      double col[50];
      col[1]=2;
      col[2]=4;
      col[3]=6;
      h_gluon1 -> SetLineColor(col[1]);
      h_gluon2 -> SetLineColor(col[2]);
      h_gluon3 -> SetLineColor(col[3]);
      h_uval1 -> SetLineColor(col[1]);
      h_uval2 -> SetLineColor(col[2]);
      h_uval3 -> SetLineColor(col[3]);
      h_dval1 -> SetLineColor(col[1]);
      h_dval2 -> SetLineColor(col[2]);
      h_dval3 -> SetLineColor(col[3]);
      h_sea1 -> SetLineColor(col[1]);
      h_sea2 -> SetLineColor(col[2]);
      h_sea3 -> SetLineColor(col[3]);
      h_gluon10 -> SetLineColor(col[1]);
      h_gluon20 -> SetLineColor(col[2]);
      h_gluon30 -> SetLineColor(col[3]);
      h_uval10 -> SetLineColor(col[1]);
      h_uval20 -> SetLineColor(col[2]);
      h_uval30 -> SetLineColor(col[3]);
      h_dval10 -> SetLineColor(col[1]);
      h_dval20 -> SetLineColor(col[2]);
      h_dval30 -> SetLineColor(col[3]);
      h_sea10 -> SetLineColor(col[1]);
      h_sea20 -> SetLineColor(col[2]);
      h_sea30 -> SetLineColor(col[3]);
      h_gluon10 -> SetLineStyle(2);
      h_gluon20 -> SetLineStyle(2);
      h_gluon30 -> SetLineStyle(2);
      h_uval10 -> SetLineStyle(2);
      h_uval20 -> SetLineStyle(2);
      h_uval30 -> SetLineStyle(2);
      h_dval10 -> SetLineStyle(2);
      h_dval20 -> SetLineStyle(2);
      h_dval30 -> SetLineStyle(2);
      h_sea10 -> SetLineStyle(2);
      h_sea20 -> SetLineStyle(2);
      h_sea30 -> SetLineStyle(2);
      gPad->SetLogy();
      double ymin1=0.0001, ymax1=10.1;
      TH2F *frame1 = new TH2F("frame1","",100,log_xmin,log_xmax,10,ymin1,ymax1);       
      frame1->SetTitle(";x; xgluon");
      frame1->Draw();    
      TLatex *text = new TLatex(-1.2,5,"p=2 GeV ");
      text->SetTextSize(0.04); 
      text -> Draw("same");
      
      
      h_gluon1 -> Draw("same");
      h_gluon2 -> Draw("same");
      h_gluon3 -> Draw("same");
      h_gluon10 -> Draw("same");
      h_gluon20 -> Draw("same");
      h_gluon30 -> Draw("same");
      h_gluon1 -> Write();
      TLegend* mylegend = new TLegend(0.6,0.74,0.8,0.85);
      mylegend->SetFillColor(0); // white background
      mylegend->SetBorderSize(0); // get rid of the borders
      mylegend->SetTextSize(0.03);
      mylegend->AddEntry(h_gluon1,"k_{t} = 0.1 GeV","l");      
      mylegend->AddEntry(h_gluon2,"k_{t} = 1 GeV","l");      
      mylegend->AddEntry(h_gluon3,"k_{t}  = 10 GeV","l");      
      mylegend->Draw();
      
      c -> cd(2) ;
      gPad->SetLogy();
      TH2F *frame2 = new TH2F("frame2","",100,log_xmin,log_xmax,10,ymin1,ymax1);       
      frame2->SetTitle(";x; xuval");
      frame2->Draw();        
      h_uval1 -> Draw("same");
      h_uval2 -> Draw("same");
      h_uval3 -> Draw("same");
      h_uval10 -> Draw("same");
      h_uval20 -> Draw("same");
      h_uval30 -> Draw("same");
      h_uval1 -> Write();
      c -> cd(3) ;
      gPad->SetLogy();
      TH2F *frame3 = new TH2F("frame3","",100,log_xmin,log_xmax,10,ymin1,ymax1);       
      frame3->SetTitle(";x; xdval");
      frame3->Draw();        
      h_dval1 -> Draw("same");
      h_dval2 -> Draw("same");
      h_dval3 -> Draw("same");
      h_dval10 -> Draw("same");
      h_dval20 -> Draw("same");
      h_dval30 -> Draw("same");
      h_dval1 -> Write();
      c -> cd(4) ;
      gPad->SetLogy();
      TH2F *frame4 = new TH2F("frame4","",100,log_xmin,log_xmax,10,ymin1,ymax1);       
      frame4->SetTitle(";x; xsea");
      frame4->Draw();        
      h_sea1 -> Draw("same");
      h_sea2 -> Draw("same");
      h_sea3 -> Draw("same");
      h_sea10 -> Draw("same");
      h_sea20 -> Draw("same");
      h_sea30 -> Draw("same");
      h_sea1 -> Write();
      
      c-> Draw();
      c->WaitPrimitive();
      gMyRootApp->SetReturnFromRun(true);
      file.Close();


} 
