// alphas for TMDlib
#include "TMDlib.h"
//using namespace TMDlib; 
using namespace std;

extern int iset, irep, imode ;

double TMDlib::TMDgetLam4( ){

if(iset < 0 ) { 
      cout << " TMDgetLam4: iset is not defined " << endl; 
      return -9999 ;}
   else if ( iset >=101000 && iset <= 101320) return 0.2  ;
   else if ( iset ==300005 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;}
   else { 
      cout << " TMDgetLam4: iset is not defined " << endl; 
      return -9999 ;}
}

int TMDlib::TMDgetNf( ){
if(iset < 0 ) { 
      cout << " TMDgetNf: iset is not defined " << endl; 
      return -9999; }
   else if ( iset >=101200 && iset <= 101320) return 4  ;
   else if ( iset ==300005 ) {
     cout << " No QCD evolution in this fit " << endl;
     return 0 ;}
}
int TMDlib::TMDgetOrderAlphaS( ){
if(iset < 0 ) { 
      cout << " TMDgetOrderAlphaS: iset is not defined " << endl; 
      return -9999 ; }
   else if ( iset >=101000 && iset <= 101200) return 1  ;
   else if ( iset >=101200 && iset <= 101320) return 2  ;
   else if ( iset ==300005 ) {
     cout << " No QCD evolution in this fit " << endl; 
     return 0 ;} 
   else { 
      cout << " TMDgetOrderAlphaS: iset is not defined " << endl; 
      return -9999 ; }
}

int TMDlib::TMDgetOrderPDF( ){
if(iset < 0 ) { 
      cout << " TMDgetOrderPDF: iset is not defined " << endl; 
      return -9999 ; }
   else if ( iset >=101000 && iset <= 101320) return 1 ;
   else if ( iset ==300005 ) return 0 ;
   else { 
      cout << " TMDgetOrderPDF: iset is not defined " << endl; 
      return -9999 ; }

}

double TMDlib::TMDgetXmin() {
if(iset < 0 ) { 
      cout << " TMDgetXmin: iset is not defined " << endl; 
      return -9999. ; }
   else if ( iset >=101000 && iset <= 101320) return 1.e-6 ;
   else if ( iset ==300005 ) return 0.06 ;
   else { 
      cout << " TMDgetXmin: iset is not defined " << endl; 
      return -9999. ; }

}

double TMDlib::TMDgetXmax() {
if(iset < 0 ) { 
      cout << " TMDgetXmax: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset >=101000 && iset <= 101320) return 1. ;
   else if ( iset ==300005 ) return 0.41 ;
   else { 
      cout << " TMDgetXmax: iset is not defined " << endl; 
      return -9999.; }

}

double TMDlib::TMDgetQ2min() {
if(iset < 0 ) { 
      cout << " TMDgetQ2min: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset ==300005 ) return 2.4 ;
   else if ( iset >=101200 && iset <= 101320) return 2.2 ;

}
double TMDlib::TMDgetQ2max() {
if(iset < 0 ) { 
      cout << " TMDgetQ2max: iset is not defined " << endl; 
      return -9999.; }
   else if ( iset ==300005 ) return 2.4 ;
   else if ( iset >=101000 && iset <= 101320) return 1.e6;
   else { 
      cout << " TMDgetQ2max: iset is not defined " << endl; 
      return -9999.; }

}

int TMDlib::TMDnumberPDF(string name) {

if(name == "" ) { cout << " TMDnumberPDF: name is not defined " << endl; }
   else if( name == "GBW" ) return 5 ;
   else if(name=="JS-2001") {
      return 101000 ;
      }
   else if(name=="JH-set-1") {
      return 101001 ;
      }
   else if(name=="JH-set-2") {
      return 101002 ;
      }
   else if(name=="JH-set-3") {
      return 101003 ;
      }
   else if(name=="ccfm-setA0") {
      return 101010 ;
      }
   else if(name=="ccfm-setA0+") {
      return 101011 ;
      }
   else if(name=="ccfm-setA0-") {
      return 101012 ;
      }
   else if(name=="ccfm-setA1") {
      return 101013 ;
      }
   else if(name=="ccfm-setB0") {
      return 101020 ;
      }
   else if(name=="ccfm-setB0+") {
      return 101021 ;
      }
   else if(name=="ccfm-setB0-") {
      return 101022 ;
      }
   else if(name=="ccfm-setB1") {
      return 101023 ;
      }
   else if(name=="ccfm-JH-2013-set1") {
      return 101201 ;
      }
   else if(name == "ccfm-JH-2013-set2") {
      return 101301 ;
      }
   else if(name == "GBWlight") {
      return 200005 ;
      }
   else if(name == "SBRS-2013-TMDPDFs") {
     return 300005 ;
      }
   else if(name == "SBRS-2013-TMDPDFs-par") {
     return 300005 ;
      }
   else { cout << " TMDnumberPDF: name is not defined " << endl; }
   
}
